      SUBROUTINE AET2P(NM,N,LOW,IGH,HR,HI,WR,WI,IERR)
         INTEGER IERR,IGH,LOW,N,NM
         DOUBLE PRECISION HI,HR,WI,WR
         DIMENSION HI(NM,N),HR(NM,N),WI(N),WR(N)
         EXTERNAL AA02P,UTAE12
         INTEGER EN,ENM1,I,II,ITS,J,L,LL,LP1
         DOUBLE PRECISION BC2,BR2,F,F1,F2,F3,MACHEP,NORM,NORM1,SI,SR,
     1                    SYS052,SYS056,TI,TR,XI,XI1,XR,XR1,YI,YR,ZZI,
     2                    ZZR
         COMPLEX*16 CZ
         DATA SYS052/2.22044592D-16/,SYS056
     1        /5.56268464627D-308/
       MACHEP = SYS052
       IERR = 0
       IF (LOW .EQ. IGH) GO TO 40
          L = LOW + 1
          DO 30 I = L, IGH
             LL = MIN0(I+1,IGH)
             IF (HI(I,I-1) .EQ. 0.00D0) GO TO 30
                NORM = CDABS(DCMPLX(HR(I,I-1),HI(I,I-1)))
                YR = HR(I,I-1)/NORM
                YI = HI(I,I-1)/NORM
                HR(I,I-1) = NORM
                HI(I,I-1) = 0.00D0
                DO 10 J = I, IGH
                   SI = YR*HI(I,J) - YI*HR(I,J)
                   HR(I,J) = YR*HR(I,J) + YI*HI(I,J)
                   HI(I,J) = SI
   10           CONTINUE
                DO 20 J = LOW, LL
                   SI = YR*HI(J,I) + YI*HR(J,I)
                   HR(J,I) = YR*HR(J,I) - YI*HI(J,I)
                   HI(J,I) = SI
   20           CONTINUE
   30     CONTINUE
   40  CONTINUE
       DO 50 I = 1, N
          IF (I .GE. LOW .AND. I .LE. IGH) GO TO 50
             WR(I) = HR(I,I)
             WI(I) = HI(I,I)
   50  CONTINUE
       EN = IGH
       TR = 0.00D0
       TI = 0.00D0
       NORM1 = 0.00D0
       II = LOW
       DO 70 I = LOW, IGH
          DO 60 J = II, IGH
             NORM1 = NORM1 + DABS(HR(I,J)) + DABS(HI(I,J))
   60     CONTINUE
          II = I
   70  CONTINUE
   80  CONTINUE
       IF (EN .LT. LOW) GO TO 250
          ITS = 0
          ENM1 = EN - 1
   90  CONTINUE
       DO 100 LL = LOW, EN
          L = EN + LOW - LL
          IF (L .EQ. LOW) GO TO 110
             F = DABS(HR(L-1,L-1)) + DABS(HI(L-1,L-1)) + DABS(HR(L,
     1           L)) + DABS(HI(L,L))
             IF (ITS .GE. 5) F = NORM1
             IF (DABS(HR(L,L-1)) .LE. F*MACHEP) GO TO 110
  100        CONTINUE
  110     CONTINUE
          IF (L .EQ. EN) GO TO 230
             IF (ITS .EQ. 30) GO TO 240
                IF (ITS .EQ. 10 .OR. ITS .EQ. 20) GO TO 130
                   SR = HR(EN,EN)
                   SI = HI(EN,EN)
                   F = DMAX1(DABS(SR),DABS(SI),DABS(HR(ENM1,ENM1)),
     1                 DABS(HI(ENM1,ENM1)))
                   F = DMAX1(F,DABS(HR(EN,ENM1)),DABS(HR(ENM1,EN)),
     1                 DABS(HI(ENM1,EN)))
                   IF (F .LE. SYS056) GO TO 140
                      XR = (HR(ENM1,EN)/F)*(HR(EN,ENM1)/F)
                      XI = (HI(ENM1,EN)/F)*(HR(EN,ENM1)/F)
                      IF (XR .EQ. 0.00D0 .AND. XI .EQ. 0.00D0)
     1                   GO TO 140
                         YR = (HR(ENM1,ENM1) - SR)/(2.00D0*F)
                         YI = (HI(ENM1,ENM1) - SI)/(2.00D0*F)
                         XR1 = YR**2 - YI**2 + XR
                         XI1 = 2.0D0*YR*YI + XI
                         CZ = CDSQRT(DCMPLX(XR1,XI1))
                         ZZR = DREAL(CZ)
                         ZZI = DIMAG(CZ)
                         IF (YR*ZZR + YI*ZZI .GE. 0.00D0) GO TO 120
                            ZZR = -ZZR
                            ZZI = -ZZI
  120                    CONTINUE
                         BR2 = YR + ZZR
                         BC2 = YI + ZZI
                         CALL AA02P(XR,XI,BR2,BC2,F1,F2)
                         SR = SR - F1*F
                         SI = SI - F2*F
                         GO TO 140
  130              CONTINUE
                   SR = DABS(HR(EN,ENM1)) + DABS(HR(ENM1,EN-2))
                   SI = 0.00D0
  140           CONTINUE
                DO 150 I = LOW, EN
                   HR(I,I) = HR(I,I) - SR
                   HI(I,I) = HI(I,I) - SI
  150           CONTINUE
                TR = TR + SR
                TI = TI + SI
                ITS = ITS + 1
                LP1 = L + 1
                DO 170 I = LP1, EN
                   SR = HR(I,I-1)
                   HR(I,I-1) = 0.00D0
                   F1 = DABS(HR(I-1,I-1))
                   F2 = DABS(HI(I-1,I-1))
                   F3 = DABS(SR)
                   F = DMAX1(F1,F2,F3)
                   F1 = F1/F
                   F2 = F2/F
                   F3 = F3/F
                   NORM = F*DSQRT(F1*F1+F2*F2+F3*F3)
                   XR = HR(I-1,I-1)/NORM
                   WR(I-1) = XR
                   XI = HI(I-1,I-1)/NORM
                   WI(I-1) = XI
                   HR(I-1,I-1) = NORM
                   HI(I-1,I-1) = 0.00D0
                   HI(I,I-1) = SR/NORM
                   DO 160 J = I, N
                      YR = HR(I-1,J)
                      YI = HI(I-1,J)
                      ZZR = HR(I,J)
                      ZZI = HI(I,J)
                      HR(I-1,J) = XR*YR + XI*YI + HI(I,I-1)*ZZR
                      HI(I-1,J) = XR*YI - XI*YR + HI(I,I-1)*ZZI
                      HR(I,J) = XR*ZZR - XI*ZZI - HI(I,I-1)*YR
                      HI(I,J) = XR*ZZI + XI*ZZR - HI(I,I-1)*YI
  160              CONTINUE
  170           CONTINUE
                SI = HI(EN,EN)
                IF (SI .EQ. 0.00D0) GO TO 180
                   NORM = CDABS(DCMPLX(HR(EN,EN),SI))
                   SR = HR(EN,EN)/NORM
                   SI = SI/NORM
                   HR(EN,EN) = NORM
                   HI(EN,EN) = 0.00D0
  180           CONTINUE
                DO 210 J = LP1, EN
                   XR = WR(J-1)
                   XI = WI(J-1)
                   DO 200 I = L, J
                      YR = HR(I,J-1)
                      YI = 0.00D0
                      ZZR = HR(I,J)
                      ZZI = HI(I,J)
                      IF (I .EQ. J) GO TO 190
                         YI = HI(I,J-1)
                         HI(I,J-1) = XR*YI + XI*YR + HI(J,J-1)*ZZI
  190                 CONTINUE
                      HR(I,J-1) = XR*YR - XI*YI + HI(J,J-1)*ZZR
                      HR(I,J) = XR*ZZR + XI*ZZI - HI(J,J-1)*YR
                      HI(I,J) = XR*ZZI - XI*ZZR - HI(J,J-1)*YI
  200              CONTINUE
  210           CONTINUE
                IF (SI .EQ. 0.00D0) GO TO 90
                   DO 220 I = L, EN
                      YR = HR(I,EN)
                      YI = HI(I,EN)
                      HR(I,EN) = SR*YR - SI*YI
                      HI(I,EN) = SR*YI + SI*YR
  220              CONTINUE
                   GO TO 90
  230        CONTINUE
             WR(EN) = HR(EN,EN) + TR
             WI(EN) = HI(EN,EN) + TI
             EN = ENM1
             GO TO 80
  240  CONTINUE
       IERR = EN
  250  CONTINUE
       IF (IERR .NE. 0) CALL UTAE12(IERR,N,5)
       RETURN
      END
